    Program HAM1
!
!  HAM1 layout.
!
!  Coordinates are referenced to HAM1,  (+X,+Y) is global (+X, +Y), 
!    The pick off beam in HAM2 starts from global (-20639, 475, -101)
!    The HAM2 table is at global (-20122, 0, -247) 
!    The septum viewport is at global (-21407, 413, -105.1) 
!    The HAM1 chamber is at global (-22692, 0, 0)
!    End viewports @ (-24317, 419, -94); (-24358, 0, 120.7); (-24317, -419, -94)
!    POP and ALS are assumed normal incident to the appropriate VP
!
    use optocad
    use rsplot
!
    character(len=128)        :: ocd(100)=''
    character(len=128)       :: mir(3)=''
    character(len=128)       :: tt(8)=''
!
    ocd(51) ='b 2053.0,  475.0,  2.1, 184.6, 0. # REFL beam'
    ocd(52) ='b 1300.0,  509.0,  2.1, 180.0, 0. # POP/ALS beam'
    ocd(53) ='b -1700.0, 419.0,  2.1,  0.0, 0. # PSL beam'
!                     
!   Chamber details
!
    ocd(2) ='i ham1_table.ocd, 0.0, 0.0, 0.0 # Table'
    ocd(30) ='i input_septum_ports.ocd, 0.0, 0.0, 0.0 # VP >>@cc0,100' 
    ocd(31) ='i viewports.ocd, 0.0, 0.0,  90.0 # VP >>@cc0,100' 
    ocd(32) ='i viewports.ocd, 0.0, 0.0, -90.0 # VP >>@cc0,100' 
    ocd(33) ='i end_viewports.ocd, 0.0, 0.0, 0.0 # VP >>@cc0,100' 
!
!   REFL Mode matching telescope dL = (3.646m, 1.395m, 0.708m, 0.268m)  
!        
    ocd(3)='i mirror, 699.0,  368.0,  137.3   % a=str,rr=0.5   # M1 >>@cc35,25'
    ocd(4)='i mirror, 700.0, -300.0,  -41.5   % a=str            # M2 >>@cc25,-25'
    ocd(5)='i     tt,-689.6, -470.6,  183.5   %cc=0.588       # TipTilt_1 >>>@cc40,100' 
    ocd(6)='i     tt, 141.3, -470.6,    4.0   %cc=-1.67       # TipTilt_2 >>>@lc60,40'
    ocd(7)='i mirror,-705.2, -589.6,  184.0   %cc=0.588,a=str  # M5 >>@cc25,-25'
    ocd(8)='i pico_mirror.ocd,   0.0, -589.6,   45.0   % a=srt, rr=0.5  # M6 >>@cc-45,-35'
    ocd(9)='i mirror, 525.0,  355.0, -134.0   % a=str            # M7 >>@cc35,25'
    ocd(10)='i refl_qpd_sled.ocd, 197.0, -627.0,  0.0          # REFL_QPD >>@'
    ocd(11)='i beam_dump.ocd, 400.0, -450.0,  0.0          # Dump_1 >>@cc100,0'
    ocd(12)='i beam_dump.ocd,-810.0, -500.0,  180.0          # Dump_2 >>@cc-100,0'
    ocd(13)='i beam_dump.ocd,-810.0, -600.0,  180.0          # Dump_3 >>@cc-100,0'
    ocd(14)='i beam_dump.ocd, 720.0, -450.0,  -90.0          # Dump_4 >>@cc100,0'
    ocd(15)='i beam_dump.ocd, 400.0, 340.0,   180.0          # Dump_5 >>@cc-120,0'
    ocd(19)='i beam_dump.ocd, 790.0, -150.0,  -90.0          # Dump_6 >>@cc100,0'
    ocd(16)='i rfpd.ocd, 0.0,-750.0, -90.0  # LSC-REFL >>@lc40,0'
    ocd(17)='i mirror, 0.0, -675.0,  -90.0    % a=t,rr=0.0,cc=0.013# L1 >>@cc50,0'
    ocd(18)='i mirror, 775.0, 370.0, 137.3    % a=str,rr=0.5,cc=0 # M14 >>@cc50,0'
    ocd(97)='i beam_diverter.ocd, 575.0,  900.0, 90.0 %        # BDiv_2 >>@cc50,60'
!
!   Green and POP  beampath
!
    ocd(21)='i mirror, 725.0, 509.0,-135.0  % a=r,cc=0.0   # M8 >>@cc25,-25'
    ocd(22)='i mirror, 725.0, 550.0,  45.0  % a=r   # M9 >>@cc25,25'
    ocd(23)='i mirror, 450.0, 550.0,-137.0  % a=str # M10 >>@cc-30,-25'
    ocd(24)='i mirror,   0.0, 547.0,-135.0  % a=r   # M11 >>@cc-30,-25'
    ocd(25)='i pico_mirror.ocd, 461.0, 700.0, 133.0  % a=str # M12 >>@cc-60,30'
    ocd(26)='i rfpd.ocd, 675.0, 700.0, 0.0 % # LSC-POP >>@lc40,0'
    ocd(27)='i mirror, 600.0, 700.0, 0.0    % a=t,rr=0.0,cc=0.013# L2 >>@cc50,0'
    ocd(98)='i beam_diverter.ocd, 450.0, 900.0, -90.0 % # BDiv_1 >>@cc30,70'
!!
!!   PSL/ALS beam path
!!    
    ocd(28)='i mirror, -530.4, 419.0,   -45.0   % a=r,cc=0.0  # M13 >>@cc40,-10' 
!
!   A 2" mirror
!
    mir(1)='p a=str, cc=0., rr=1.0'
    mir(2)='d @a,  0.,  0.,  rd=25.4,  ag=0., c=cc, r=rr #Mirror@lc9,-7'
    mir(3)=' +  t,  dx=9.5, da=180.0'
!
!   Tip Tilt optic
!
    tt(1) ='p a=str, cc=0.'
    tt(2) ='d  str, 0.0, 0.0, rd=25.4 # TipTilt'
    tt(3) ='+  t, dm=9.0, da=180'
    tt(4) ='d  h, -26., 0.,  rd= 62, icc=13 '
    tt(5) ='+  h, dm=90.0, da=180'
    tt(6) ='h  h, -26., 0., rd=25.4'
    tt(7) ='+  h, dm=90.0, rd=25.4'  
!
    call oc_init(unit='mm', &         ! Initialize OPTOCAD 
                 pform = 'LETTER_L', &  !Landscape letter size
                 prt='nwe')           ! Display errors
     call oc_frame(-1700.,-1500.,1500.0,1500., &  !frame at xbeg, ybeg, xend, yend
         xbl=25., &                                                  ! bottom left in paper units
         ybl=25., &                                                  ! bottom left in paper units
         scale=0.06, &                                           ! scale
         glp=0)                                                        ! line style
    
    call oc_set(nice = 1,        &     ! One iteration for cavity eigenray
                pstat= 0,        &     ! Switch off output of statistics
                      fslb = 2.,       &     ! Font size for labels (mm)
                      rix = (/1.44963/), & ! index of refraction
                      mct=2,    & ! Cavity treatment (2=resonance, 3=resonance+eigenmode)
                      pctl=0,      & ! show cavity test cycle
                print='rs s1 s2 act x1 y1 x2 y2 rd  w1t w2t lb', &
                write='rs x1 y1 x2 y2  Gp1 Gp2 lb')
    call oc_bind('mirror',mir)
    call oc_bind('tt',tt)
    call oc_input(ocd)                 ! read in data of optical components
!
    call oc_trace(1, of='ham1_REFL.txt')                      ! Trace REFL ray segments
    call oc_beam(3.0,fill=ps_color((/1.,.8,.8/)))! Plot outer part of beam
    call oc_beam(2.0,fill=ps_color((/1.,.6,.6/)))! Plot middle part of beam
    call oc_beam(1.0,fill=2)                     ! Plot inner part of beam
    call oc_beam(0.0,1,5,.2)     ! Plot the beam axes in black 
    call oc_reset()
!
    call oc_trace(2, of='ham1_ALS.txt')                      ! Trace ALS ray segments
    call oc_beam(3.0,fill=ps_color((/.8,1.,.8/)))! Plot outer part of beam
    call oc_beam(2.0,fill=ps_color((/.6,1.,.6/)))! Plot middle part of beam
    call oc_beam(1.0,fill=3)                     ! Plot inner part of beam
    call oc_beam(0.0,1,5,.2)     ! Plot the beam axes in black 
    call oc_reset()
!    
    call oc_trace(3, of='ham1_PSL.txt')                      ! Trace ALS ray segments
    call oc_beam(3.0,fill=ps_color((/.8,.8,1./)))! Plot outer part of beam
    call oc_beam(2.0,fill=ps_color((/.6,.6,1./)))! Plot middle part of beam
    call oc_beam(1.0,fill=4)                     ! Plot inner part of beam
    call oc_beam(0.0,1,5,.2)     ! Plot the beam axes in black 
                                 ! (add rnc=1 to plot numbers)
    call oc_surf(lw=.3)          ! Plot all surfaces with linewidth 0.3mm
!
    call oc_exit
    end                    
